int latchPin = 8;
int clockPin = 12;
int dataPin = 11;

byte LEDs[8][8] = {
  {0, 0, 0, 1, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0}
};

// Single firework
int currentSection = 15;
int endSectionCount = 16;
byte sections[16][8] = {
{16,2,128,0,2,64,0,8},
{8,128,2,0,0,130,0,16},
{16,2,128,0,2,64,0,8},
{8,128,2,0,0,130,0,16},
{16,2,128,0,2,64,0,8},
{0,0,0,16,0,0,0,0},
{0,0,0,16,0,0,0,0},
{0,0,0,16,0,0,0,0},
{0,0,0,16,0,0,0,16},
{0,0,16,0,0,0,16,16},
{0,16,0,0,0,16,16,255},
{16,0,0,0,16,16,255,255},
{0,16,0,0,16,16,255,255},
{0,0,16,0,16,16,255,255},
{0,0,0,16,16,16,255,255},
{0,0,0,0,16,16,255,255},
};

void setup() {
  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
}

void loop() {
  redrawMatrix(currentSection);
  if (currentSection > 0) {
    currentSection--;
  }
  else {
    currentSection = 15;
  }
  for (int i = 0; i < 10; i++) { // Redraw light up to fill in the time
    lightLED();
  }
}

void redrawMatrix(int sectionSelection) {
  for (int row = 0; row < 8; row++) {
    byte data = sections[sectionSelection][row];
    for (byte column = 0; column < 8; column++) {
      if (data & (1<<column)) {
        LEDs[row][7-column] = 1;
      }
      else {
        LEDs[row][7-column] = 0;
      }
    }
  }  
}

void lightLED() {
  byte columnbitsToSend = 0;
  byte rowbitsToSend = 0;
  
  int x = 0;
  int y = 0;
  for (x = 0; x < 8; x++) {
    columnbitsToSend = 0;
    rowbitsToSend = 0;
    
    for (y = 0; y < 8; y++) {
      if (LEDs[x][y] == 1) {
        bitWrite(rowbitsToSend, y, HIGH);
      } 
    }
    
    digitalWrite(latchPin, LOW);
    bitWrite(columnbitsToSend, x, HIGH);
    shiftOut(dataPin, clockPin, MSBFIRST, (0xFF ^ rowbitsToSend)); // GND 595
    shiftOut(dataPin, clockPin, MSBFIRST, columnbitsToSend); // VCC 595
    digitalWrite(latchPin, HIGH);   
    delay(2);
  }
}
